Attribute VB_Name = "mdlFileSystem"
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' Erforderliche API
Private Declare Function GetVolumeInformation Lib "Kernel32" Alias _
    "GetVolumeInformationA" (ByVal lpRootPathName As String, _
    ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, _
    lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, _
    lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, _
    ByVal nFileSystemNameSize As Long) As Long

' Ist das Dateisystem NTFS
Private Function IsNTFS(ByVal DriveName As String)
   IsNTFS = (GetFileSystemName(DriveName) = "NTFS")
End Function

' Ist das Dateisystem HFS
Private Function IsHFS(ByVal DriveName As String)
   IsHFS = (GetFileSystemName(DriveName) = "HFS")
End Function

' Ist unser Dateisystem fr den weiteren Programmablauf in Ordnung?
' Falls DriveName nicht bergeben wurde, wird das aktuelle Laufwerk geprft
Public Function IsValidFileSystem(Optional ByVal DriveName As String = vbNullString) As Boolean
   IsValidFileSystem = (IsHFS(DriveName) Or IsNTFS(DriveName))
End Function

' Dateisystemnamen auslesen
Private Function GetFileSystemName(ByVal DriveName As String) As String
   Dim Dummy  As String ' Dummy
   Dim FSName As String ' Buffer
   Dim RetVal As Long   ' Rckgabe

   ' Buffer fllen
   FSName = String$(255, Chr$(0))
   
   ' API aufrufen
   RetVal = GetVolumeInformation(DriveName, Dummy, 0&, 0&, 0&, 0&, FSName, 255)
   
   ' Hier gibts ein Problem
   If RetVal = 0 Then
      Call MsgBox("Ein Fehler ist beim Lesen des Dateisystems aufgetreten", _
        vbCritical, "Fehler")
      GetFileSystemName = vbNullString
      Exit Function
   End If

   ' Ausgabe trimmen
   FSName = Strings.Left$(FSName, Strings.InStr(1, FSName, Chr$(0)) - 1)

   GetFileSystemName = Strings.UCase(FSName)
End Function

